variable "REG" {
  default = "git.snrd.eu"
}
variable "REPO" {
  default = "sunred/discord-tweeter"
}
variable "TAG" {
  default = "latest"
}

group "default" {
  targets = ["prod"]
}

target "default" {
  #platforms = [ "linux/amd64", "linux/arm64", "linux/arm/v7", "linux/riscv64" ]
  platforms = [ "linux/amd64", "linux/arm64" ]
  tags = ["${REG}/${REPO}:latest", "${REG}/${REPO}:${TAG}"]
  attest = [
    "type=provenance,disabled=true",
    "type=sbom,disabled=true"
  ]
}
target "prod" {
  inherits = ["default"]
  #dockerfile = "Dockerfile"
  dockerfile = "Dockerfile.multiarch"
  output = ["type=registry"]
}
target "dev" {
  inherits = ["default"]
  dockerfile = "Dockerfile.multiarch"
  output = ["type=image"]
}
